### 服务内存参数设置
docker-compose.yml 环境配置
```yaml
   environment:
      PARAMS: -server -Xmx1g -Xms1g -Dspring.profiles.active=prod -Dwhrp.third-party-services=classify,hbhy,runpu,iview -Dspring.config.location=/root/app/conf/

```


-Xmx1g
JVM预计分配的最大堆内存1g
-Xms1g
JVM预计分配的起始堆内存1g

建议两个值设为一致，另外该内存值，不应超过物理内存的一半，具体根据硬件配置设置。
例如： 
caseinfo 为主业务服务，那么可以把他设置高一点，
user 服务访问频率过低，可以设置低一点
basic服务，如涉及到文件转换，比如生成缩略图，双层PDF等，那么也要把内存设置的高一些

### 环境配置
-Dspring.profiles.active=prod
prod：生产环境
test： 测试环境
dev： 开发环境

### 数据库连接池配置
```yaml
datasource:
    driver-class-name: com.mysql.cj.jdbc.Driver
    username: root
    password: xxxxxxx
    url: jdbc:mysql://mysql:3306/dossier?useUnicode=true&characterEncoding=utf8&serverTimezone=Asia/Shanghai&useSSL=false
    hikari:
      pool-name: Retail_HikariCP
      minimum-idle: 3 #最小空闲连接数量
      idle-timeout: 180000 #空闲连接存活最大时间，默认600000（10分钟）
      maximum-pool-size: 10 #连接池最大连接数，默认是10
      auto-commit: true  #此属性控制从池返回的连接的默认自动提交行为,默认值：true
      max-lifetime: 1800000 #此属性控制池中连接的最长生命周期，值0表示无限生命周期，默认1800000即30分钟
      connection-timeout: 30000 #数据库连接超时时间,默认30秒，即30000
      connection-test-query: SELECT 1
```
生产环境，根据当前服务器配置修改
 minimum-idle :  初始化的连接池数量，建议10-20
maximum-pool-size： 最大连接池数量，建议50-100