#### 1.安装keepalived
```shell
yum -y install keepalived
```

#### 2.主服务配置
```shell
cd /etc/keepalived
mv keepalived.conf keepalived.conf.bak
vim keepalived.conf

```
修配置文件如下：
```
#检测脚本
vrrp_script chk_http_port {
    script "/etc/keepalived/check_nginx.sh" #心跳执行的脚本，检测业务服务是否启动
    interval 2                          #（检测脚本执行的间隔，单位是秒）
    weight 2                            #权重
}
#vrrp 实例定义部分
vrrp_instance VI_1 {
    state MASTER            # 指定keepalived的角色，MASTER为主，BACKUP为备
    interface enp1s0         # 当前进行vrrp通讯的网络接口卡(当前centos的网卡) 用ifconfig查看你具体的网卡
    virtual_router_id 66    # 虚拟路由编号，主从要一直
    priority 100            # 优先级，数值越大，获取处理请求的优先级越高
    advert_int 1            # 检查间隔，默认为1s(vrrp组播周期秒数)
    #授权访问
    authentication {
        auth_type PASS #设置验证类型和密码，MASTER和BACKUP必须使用相同的密码才能正常通信
        auth_pass 1$a4CGofw8Wxyz1v
    }
    track_script {
        chk_http_port            #（调用检测脚本）
    }
    virtual_ipaddress {
        192.168.0.39            # 定义虚拟ip(VIP)，可多设，每行一个
    }
}

```

```shell
vim /etc/keepalived/check_nginx.sh
```
脚本内容如下：
```shell
#!/bin/bash
#检测docker 服务是否启动了，该案例用的是nginx，其他服务，自己换容器名称
A=`docker ps | grep 'nginx-review' |wc -l`
if [ $A -eq 0 ];then    #如果nginx没有启动就启动nginx
      docker start nginx-review                #启动容器
      if [ `docker ps | grep 'nginx-review' |wc -l` -eq 0 ];then    #重启失败，则停掉keepalived服务，进行VIP转移
              killall keepalived
      fi
fi

```

该脚本加执行权限
```shell
chmod +x /etc/keepalived/check_nginx.sh
```

#### 3.从服务配置
在从服务器上，执行1-2 步骤，其 keepalived.conf 配置修改如下：
```shell
vrrp_script chk_http_port {
    script "/etc/keepalived/check_nginx.sh" #心跳执行的脚本，检测nginx是否启动
    interval 2                          #（检测脚本执行的间隔，单位是秒）
    weight 2                            #权重
}
#vrrp 实例定义部分
vrrp_instance VI_1 {
    state BACKUP            # 指定keepalived的角色，MASTER为主，BACKUP为备
    interface enp2s0f0        # 当前进行vrrp通讯的网络接口卡(当前centos的网卡) 用ifconfig查看你具体的网卡
    virtual_router_id 66    # 虚拟路由编号，主从要一直
    priority 99            # 优先级，数值越大，获取处理请求的优先级越高
    advert_int 1            # 检查间隔，默认为1s(vrrp组播周期秒数)
    #授权访问
    authentication {
        auth_type PASS #设置验证类型和密码，MASTER和BACKUP必须使用相同的密码才能正常通信
        auth_pass 1$a4CGofw8Wxyz1v
    }
    track_script {
        chk_http_port            #（调用检测脚本）
    }
    virtual_ipaddress {
        192.168.0.39            # 定义虚拟ip(VIP)，可多设，每行一个
    }
}

```


参考资料：
[Nginx 挂了怎么办？怎么实现高可用？](https://zhuanlan.zhihu.com/p/401613694 "Nginx 挂了怎么办？怎么实现高可用？")
[高可用——keepalived组件实用指南](https://baijiahao.baidu.com/s?id=1711139656361233985&wfr=spider&for=pc "高可用——keepalived组件实用指南")